package net.sweevo.jinks.commands;

import com.mojang.brigadier.Command;
import com.mojang.brigadier.builder.ArgumentBuilder;
import com.mojang.brigadier.context.CommandContext;
import net.minecraft.ChatFormatting;
import net.minecraft.commands.CommandSourceStack;
import net.minecraft.commands.Commands;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.network.chat.Style;
import net.minecraft.server.level.ServerPlayer;
import net.sweevo.jinks.BackupData;
import net.sweevo.jinks.BackupThread;
import net.sweevo.jinks.ExtBackup;
import net.sweevo.jinks.config.CommonConfig;

public class StatusCommand implements Command<CommandSourceStack> {

    public static ArgumentBuilder<CommandSourceStack, ?> register() {
        return Commands.literal("status")
                .executes(new StatusCommand());
    }

    @Override
    public int run(CommandContext<CommandSourceStack> context) {
        BackupData data = BackupData.get(context.getSource().getServer());
        String paused = data.isPaused() ? "true" : "false";
        String nextUp = data.getNextBackup();
        ServerPlayer player = context.getSource().getPlayer();
        MutableComponent message = BackupThread.component(player, "Backups paused: %s. - Next backup: %s", paused, nextUp);
        if (player != null) {
            player.sendSystemMessage(message.withStyle(Style.EMPTY.withColor(ChatFormatting.BLUE)));
        } else {
            ExtBackup.LOGGER.info(String.valueOf(message));
        }
        return 0;
    }
}
